using Backend.Common;
using Backend.Models;
using Backend.Services.Interface;
using MediatR;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Reflection;
using System.Threading;
using System.Threading.Tasks;

namespace Mediator
{
    public class GetCommandeListHandler : IRequestHandler<GetCommandeListQuery, IEnumerable<CommandeResponse>>
    {
        private readonly ICommandeService _CommandeService;
        private readonly ILogger<GetCommandeListHandler> _log;
        public GetCommandeListHandler(ILogger<GetCommandeListHandler> log, ICommandeService CommandeService) 
        {
            _log = log;
            _CommandeService = CommandeService;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="request"></param>
        /// <param name="cancellationToken"></param>
        /// <returns></returns>
        public async Task<IEnumerable<CommandeResponse>> Handle(GetCommandeListQuery request, CancellationToken cancellationToken)
        {
            _log.LogDebug($"{this.GetType().Name} -> {MethodBase.GetCurrentMethod()} - Handle of Type");
            if (_CommandeService != null) 
            {
                using Task<IEnumerable<CommandeResponse>> task = _CommandeService.GetAll();
                await task;
                if (task.IsCompleted && task.IsCompletedSuccessfully)
                {
                    return task.Result;
                }
                else
                {
                    _log.LogError($"{this.GetType().Name} -> {MethodBase.GetCurrentMethod()} - {ErrorsConstants.C_SERVICE_MSG_ERROR + ": Type"}");
                    throw new Exception(ErrorsConstants.C_SERVICE_MSG_ERROR + ": Type");
                }
            }
            else
            {
                _log.LogError($"{this.GetType().Name} -> {MethodBase.GetCurrentMethod()} - {ErrorsConstants.C_APPLICATION_DBCONTEXT_NULL_MSG}");
                throw new ArgumentNullException(ErrorsConstants.C_APPLICATION_DBCONTEXT_NULL_MSG);
            }
        }
    }
}
